diff --git a/doc/manual.xml.head b/doc/manual.xml.head
index 6f2d7413cb..25fc009032 100644
--- a/doc/manual.xml.head
+++ b/doc/manual.xml.head
@@ -4590,8 +4590,8 @@ unignore posted-to:
       <link linkend="shortcuts">mailbox shortcut</link>expansion performed on
       the first character. See
       <xref linkend="mailbox-hook" />for more details.</para>
-      <para>Note that execution of mbox-hooks is dependent on the 
-      <link linkend="move">$move</link>configuration variable. If set to 
+      <para>Note that execution of mbox-hooks is dependent on the
+      <link linkend="move">$move</link>configuration variable. If set to
       <quote>no</quote>(the default), mbox-hooks will not be executed.</para>
       <para>Unlike some of the other
       <emphasis>hook</emphasis>commands, only the
@@ -5082,9 +5082,9 @@ message-hook '~f freshmeat-news' 'set pager="less \"+/^  subject: .*\""'
       score entries.</para>
 
       <para>Scoring occurs as the messages are read in, before the mailbox is
-      sorted. Because of this, patterns which depend on threading, such as 
-      <emphasis>~=</emphasis>, 
-      <emphasis>~$</emphasis>, and 
+      sorted. Because of this, patterns which depend on threading, such as
+      <emphasis>~=</emphasis>,
+      <emphasis>~$</emphasis>, and
       <emphasis>~()</emphasis>, will not work by default. A workaround is to push
       the scoring command in a folder hook. This will cause the mailbox to be
       rescored after it is opened and input starts being processed:</para>
@@ -5485,8 +5485,7 @@ set spam_separator=", "
             readability</title>
             <screen>
 set my_cfgdir = $HOME/mutt/config
-source $my_cfgdir/hooks
-source $my_cfgdir/macros
+source $my_cfgdir/hooks $my_cfgdir/macros
 <emphasis role="comment"># more source commands...</emphasis>
 </screen>
           </example>
@@ -5594,7 +5593,8 @@ mailboxes $my_mx +mailbox3</screen>
       <cmdsynopsis>
         <command>source</command>
         <arg choice="plain">
-          <replaceable class="parameter">filename</replaceable>
+          <replaceable class="parameter">file1</replaceable>
+          <replaceable class="parameter">file2</replaceable>
         </arg>
       </cmdsynopsis>
       <para>This command allows the inclusion of initialization commands from
diff --git a/init.c b/init.c
index 63226e6966..02acd0acde 100644
--- a/init.c
+++ b/init.c
@@ -3136,24 +3136,31 @@ static int source_rc(const char *rcfile_path, struct Buffer *err)
 
 #undef MAXERRS
 
-static int parse_source(struct Buffer *tmp, struct Buffer *s,
+static int parse_source(struct Buffer *tmp, struct Buffer *token,
                         unsigned long data, struct Buffer *err)
 {
   char path[_POSIX_PATH_MAX];
 
-  if (mutt_extract_token(tmp, s, 0) != 0)
-  {
-    snprintf(err->data, err->dsize, _("source: error at %s"), s->dptr);
-    return -1;
-  }
-  if (MoreArgs(s))
+  do
   {
-    strfcpy(err->data, _("source: too many arguments"), err->dsize);
-    return -1;
-  }
-  strfcpy(path, tmp->data, sizeof(path));
-  mutt_expand_path(path, sizeof(path));
-  return source_rc(path, err);
+    if (mutt_extract_token(tmp, token, 0) != 0)
+    {
+      snprintf(err->data, err->dsize, _("source: error at %s"), token->dptr);
+      return -1;
+    }
+    strfcpy(path, tmp->data, sizeof(path));
+    mutt_expand_path(path, sizeof(path));
+
+    if (source_rc(path, err) < 0)
+    {
+      snprintf(err->data, err->dsize,
+               _("source: file %s could not be sourced."), path);
+      return -1;
+    }
+
+  } while (MoreArgs(token));
+
+  return 0;
 }
 
 /* line         command to execute
